Controllers/ActorsController.cs
using eTicket.Data;
using eTicket.Data.Services;
using eTicket.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace eTicket.Controllers
{
    public class ActorsController : Controller
    {
        private readonly IActorService _service;
        public ActorsController(IActorService service)
        {
            _service = service;
        }
        public async Task<IActionResult> Index()
        {
            var data =await _service.GetAllAsync();
            //data = new Data()
            //data = new List<Actor>(); 
            return View(data);
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> Create(Actor actor)
        {
            if (!ModelState.IsValid)
            {
                return View(actor);
            }
            await _service.AddAsync(actor);
            
            return RedirectToAction(nameof(Index)); 
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            var actorDetails = await _service.GetByIdAsync(id);
            if (actorDetails == null)
            {
                return View("NotFound");
            }
            return View(actorDetails);
        }

        [HttpPost,ActionName("Delete")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var actorDetails = await _service.GetByIdAsync(id);
            if (actorDetails == null)
            {
                return View("NotFound");
            }
            await _service.DeleteAsync(id);
            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {
            var actorDetails = await _service.GetByIdAsync(id);
            if (actorDetails == null)
            {
                return View("NotFound");
            }
            return View(actorDetails);
        }

        [HttpPost]
        public async Task<IActionResult> Edit(int id,Actor actor)
        {
            if (!ModelState.IsValid)
            {
                return View(actor);
            }
            await _service.UpdateAsync(id,actor);

            return RedirectToAction(nameof(Index));
        }
        public async Task<IActionResult> Details(int id)
        {
            var actorDetails =await _service.GetByIdAsync(id);
            if (actorDetails == null)
            {
                return View("NotFound");
            }
            return View(actorDetails);
        }
    }
}

Controllers/CinemasController.cs
using eTicket.Data;
using eTicket.Data.Services;
using eTicket.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace eTicket.Controllers
{
    public class CinemasController : Controller
    {
        private readonly ICinemaService _service;
        public CinemasController(ICinemaService service)
        {
            _service = service;
        }
        public async Task<IActionResult> Index()
        {
            var data = await _service.GetAllAsync();            
            return View(data);
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> Create(Cinema cinema)
        {
            if (!ModelState.IsValid)
            {
                return View(cinema);
            }
            await _service.AddAsync(cinema);
            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            return View(producersDetails);
        }

        [HttpPost, ActionName("Delete")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            await _service.DeleteAsync(id);
            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            return View(producersDetails);
        }

        [HttpPost]
        public async Task<IActionResult> Edit(int id, Cinema cinema)
        {
            if (!ModelState.IsValid)
            {
                return View(cinema);
            }
            await _service.UpdateAsync(id, cinema);

            return RedirectToAction(nameof(Index));
        }
        public async Task<IActionResult> Details(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            return View(producersDetails);
        }
    }
}

Controllers/MoviesController.cs
using eTicket.Data;
using eTicket.Data.Services;
using eTicket.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace eTicket.Controllers
{
    public class MoviesController : Controller 
    {
        private readonly IMovieService _service;
        public MoviesController(IMovieService service)
        {
            _service = service;
        }
        public async Task<IActionResult> Index()
        {
            //var data = await _service.Movies.Include(x=>x.Cinema).OrderBy(x=>x.Name).ToListAsync();
            var data = await _service.GetAllAsync(n=> n.Cinema);
            return View(data);
        }

        public async Task<IActionResult> Filter(string searchString)
        {
            //var data = await _service.Movies.Include(x=>x.Cinema).OrderBy(x=>x.Name).ToListAsync();
            var data = await _service.GetAllAsync(n => n.Cinema);

            if (!string.IsNullOrEmpty(searchString))
            {
                var filteredResult = data.Where(x => x.Name.Contains(searchString) || x.Description.Contains(searchString)).ToList();
                return View("Index", filteredResult);
            }
            return View("Index",data);
        } 

        [HttpGet]
        public async Task<IActionResult> Create()
        {
            var movieDropdownsData = await _service.GetNewMovieDropdownsValue();

            ViewBag.Cinemas = new SelectList(movieDropdownsData.Cinemas,"Id","Name");
            ViewBag.Producers = new SelectList(movieDropdownsData.Producers,"Id","FullName");
            ViewBag.Actors = new SelectList(movieDropdownsData.Actors,"Id","FullName");

            return View();
        }

        [HttpPost]
        public async Task<IActionResult> Create(MovieViewModel movie)
        {
            
            if (!ModelState.IsValid)
            {
                var movieDropdownsData = await _service.GetNewMovieDropdownsValue();
                ViewBag.Cinemas = new SelectList(movieDropdownsData.Cinemas, "Id", "Name");
                ViewBag.Producers = new SelectList(movieDropdownsData.Producers, "Id", "FullName");
                ViewBag.Actors = new SelectList(movieDropdownsData.Actors, "Id", "FullName");

                return View(movie);
            }
            await _service.AddNewMovieAsync(movie);
            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound"); 

            }
            return View(producersDetails);
        }

        [HttpPost, ActionName("Delete")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var moviesDetails = await _service.GetByIdAsync(id);
            if (moviesDetails == null)
            {
                return View("NotFound");
            }
            await _service.DeleteAsync(id);
            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {
            var moviesDetails = await _service.GetMovieByIdAsync(id);
            if (moviesDetails == null)
            {
                return View("NotFound");
            }

            var response = new MovieViewModel()
            {
                Id = moviesDetails.Id,
                Name = moviesDetails.Name,
                Description = moviesDetails.Description,
                Price = moviesDetails.Price,
                ImageURL = moviesDetails.ImageURL,
                StartDate = moviesDetails.StartDate,
                EndDate = moviesDetails.EndDate,
                MovieCategory = moviesDetails.MovieCategory,
                CinemaId = moviesDetails.CinemaId,
                ProducerId = moviesDetails.ProducerId,
                ActorIds = moviesDetails.Actors_Movies.Select(x => x.ActorId).ToList(),
            };


            var movieDropdownsData = await _service.GetNewMovieDropdownsValue();

            ViewBag.Cinemas = new SelectList(movieDropdownsData.Cinemas, "Id", "Name");
            ViewBag.Producers = new SelectList(movieDropdownsData.Producers, "Id", "FullName");
            ViewBag.Actors = new SelectList(movieDropdownsData.Actors, "Id", "FullName");

            return View(response);
        }

        [HttpPost]
        public async Task<IActionResult> Edit(int id, MovieViewModel movie)
        {

            if (id!=movie.Id)
            {
                return View("Not Found");
            }

            if (!ModelState.IsValid)
            {
                var movieDropdownsData = await _service.GetNewMovieDropdownsValue();

                ViewBag.Cinemas = new SelectList(movieDropdownsData.Cinemas, "Id", "Name");
                ViewBag.Producers = new SelectList(movieDropdownsData.Producers, "Id", "FullName");
                ViewBag.Actors = new SelectList(movieDropdownsData.Actors, "Id", "FullName");

                return View(movie);
            }
            

            await _service.UpdateMovieAsync(movie);
            return RedirectToAction(nameof(Index));
        }
        public async Task<IActionResult> Details(int id)
        {
            var moviesDetails = await _service.GetMovieByIdAsync(id);
            if (moviesDetails == null)
            {
                return View("NotFound");
            }
            return View(moviesDetails);
        }
    }
}

Controllers/OrdersController.cs
using eTicket.Data.Cart;
using eTicket.Data.Services;
using eTicket.Data.ViewModels;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace eTicket.Controllers
{
    public class OrdersController : Controller
    {
        private readonly IMovieService _movieService;
        private readonly ShoppingCart _shoppingCart;
        private readonly IOrderServices _orderService;

        public OrdersController(IMovieService movieService, ShoppingCart shoppingCart, IOrderServices orderService)
        {
            _movieService = movieService;
            _shoppingCart = shoppingCart;
            _orderService = orderService;    
        }


        public IActionResult Index()
        {
            var items = _shoppingCart.GetShoppingCartItems();
            _shoppingCart.ShoppingCartItems = items;
            var response = new ShoppingCartVM()
            {
                ShoppingCart = _shoppingCart,
                ShoppingCartTotal = _shoppingCart.GetShoppingCartTotal()
            };
            return View(response);
        }
        public async Task<IActionResult> OrderIndex()
        {
            string userId = "";
            var orders = await _orderService.GetOrdersByUserIdAsync(userId);
            return View(orders);
        }

        public async Task<RedirectToActionResult> AddItemToShoppingCart(int id)
        {
            var item = await _movieService.GetMovieByIdAsync(id);
            if (item != null)
            {
                _shoppingCart.AddItemToCart(item);
            }
            return RedirectToAction(nameof(Index));            
        }

        public async Task<RedirectToActionResult> RemoveItemFromShoppingCart(int id)
        {
            var item = await _movieService.GetMovieByIdAsync(id);
            if (item != null)
            {
                _shoppingCart.RemoveItemFromCart(item);//
            }
            return RedirectToAction(nameof(Index));
        }
        public async Task<IActionResult> CompleteOrder()
        {
            var items = _shoppingCart.GetShoppingCartItems();
            string userId = "";
            string userEmailAddress = "";

            await _orderService.StoreOrderAsync(items, userId, userEmailAddress);
            await _shoppingCart.ClearShoppingCart();
            return View("OrderCompleted");
        }
    }
}
 

Controllers/ProducersController.cs
using eTicket.Data;
using eTicket.Data.Services;
using eTicket.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace eTicket.Controllers    
{
    public class ProducersController : Controller
    {
        private readonly IProducerService _service;
        public ProducersController(IProducerService service)
        {
            _service = service;
        }
        //public async Task<IActionResult> Index()
        //{
        //    var data = await _context.Producers.ToListAsync();
        //    return View(data);
        //}

        public async Task<IActionResult> Index()
        {
            var data =await _service.GetAllAsync();
            //data = new Data()
            //data = new List<Actor>(); 
            return View(data);
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> Create(Producer producer)
        {
            if (!ModelState.IsValid)
            {
                return View(producer);
            }
            await _service.AddAsync(producer);            
            return RedirectToAction(nameof(Index)); 
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            return View(producersDetails);
        }

        [HttpPost,ActionName("Delete")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            await _service.DeleteAsync(id);
            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {
            var producersDetails = await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            return View(producersDetails);
        }

        [HttpPost]
        public async Task<IActionResult> Edit(int id, Producer producer)
        {
            if (!ModelState.IsValid)
            {
                return View(producer);
            }
            await _service.UpdateAsync(id,producer);                      
            return RedirectToAction(nameof(Index));
        }
        public async Task<IActionResult> Details(int id)
        {
            var producersDetails =await _service.GetByIdAsync(id);
            if (producersDetails == null)
            {
                return View("NotFound");
            }
            return View(producersDetails);
        }
    }
}

Views/Movies/Create.cshtml
@model MovieViewModel
@using eTicket.Data;
@{
    ViewData["Title"] = "Create a New movie";
}

<div class="row">
    <div class="col-md-8 offset-2">
        <p>
            Create New Movie
        </p>

        <div class="row">


            <div class="col-md-8 offset-2">
                <form asp-action="Create">
                    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label asp-for="Name" class="control-label"></label>
                                <input asp-for="Name" class="form-control" />
                                <span asp-validation-for="Name" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="StartDate" class="control-label"></label>
                                <input asp-for="StartDate" type="date" class="form-control" />
                                <span asp-validation-for="StartDate" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="EndDate" class="control-label"></label>
                                <input asp-for="EndDate" type="date" class="form-control" />
                                <span asp-validation-for="EndDate" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="Price" class="control-label"></label>
                                <input asp-for="Price" type="number" class="form-control" />
                                <span asp-validation-for="Price" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="ImageURL" class="control-label"></label>
                                <input asp-for="ImageURL" class="form-control" />
                                <span asp-validation-for="ImageURL" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label asp-for="CinemaId" class="control-label"></label>
                                <select asp-for="CinemaId" class="form-control" asp-items="ViewBag.Cinemas"></select>
                                <span asp-validation-for="CinemaId" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="MovieCategory" class="control-label"></label>
                                <select asp-for="MovieCategory" class="form-control" asp-items="Html.GetEnumSelectList<MovieCategory>()"></select> 
                                <span asp-validation-for="MovieCategory" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="ProducerId" class="control-label"></label>
                                <select asp-for="ProducerId" class="form-control" asp-items="ViewBag.Producers"></select>
                                <span asp-validation-for="ProducerId" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="ActorIds" class="control-label"></label>
                                <select asp-for="ActorIds" class="form-control" asp-items="ViewBag.Actors" multiple></select>
                                <span asp-validation-for="ActorIds" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group">
                                <label asp-for="Description" class="control-label"></label>
                                <textarea asp-for="Description" class="form-control"></textarea>
                                <span asp-validation-for="Description" class="text-danger"></span>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-4 offset-4 text-center">
                        <img width="100%" id="ImageUrlPreview"/>
                    </div>
                    <div>
                        <input type="submit" value="Create" class="btn btn-outline-success float-right"/>
                        <a class=" btn btn-outline-secondary" asp-action="Index">Show All</a>
                    </div>
                </form>
            </div>

        </div>
    </div>
</div>

@section Scripts{
    <script>
        $('#ImageURL').on("change",function(){
            var output = document.getElementById("ImageUrlPreview");
            output.src = $(this).val();
        })
    </script>
}

Views/Movies/Details.cshtml
@model Movie

@{
ViewData["Title"] = "Movie Details";
}

<h1>Index</h1>

<p>
<a asp-action="Create">Create New</a>
</p>
<div class="row">
    <div class="col-md-8 offset-2">
        <div class="card mb-12">
            <div class="row g-0">
                <div class="col-md-12">
                    <div class="card-header text-white bg-info">
                        <p class="card-text">
                            <h5 class="card-title">
                                @Model.Name
                            </h5>
                        </p>
                    </div>
                </div>
                <div class="col-md-4">
                    <img src="@Model.ImageURL" width="100%" alt="@Model.Name" />                        
                </div>
                <div class="col-md-8">
                    <div class="card-body">
                        <p class="card-text">@Model.Description</p>
                        <p class="card-text">
                            <b>Cinema: </b>
                            <a asp-controller="Cinemas" asp-action="Details" asp-route-id="@Model.CinemaId">@Model.Cinema.Name</a>
                        </p>
                        <p class="card-text">
                            <b>Producer: </b>
                            <a asp-controller="Producers" asp-action="Details" asp-route-id="@Model.ProducerId">@Model.Producer.FullName</a>
                        </p>
                        <p class="card-text"><b>Category: </b>@Model.MovieCategory</p>
                        <p class="card-text"><b>Start Date: </b>@Model.StartDate.ToShortDateString() </p>
                        <p class="card-text"><b>End Date: </b>@Model.EndDate.ToShortDateString()</p>
                        <p class="card-text">
                            <b>Status: </b>
                            @if (DateTime.Now >= Model.StartDate && DateTime.Now <= Model.EndDate)
                            {
                                <span class="badge bg-success text-white">AVAILABLE</span>
                            }
                            else if (DateTime.Now > Model.EndDate)
                            {
                                <span class="badge bg-danger text-white">Expired</span>
                            }
                            else
                            {
                                <span class="badge bg-success text-white">Upcomming</span>
                            }
                        </p>
                        <p class="card-text">
                            <b>Actors: </b>
                            <hr />
                            <div class="row">
                                @foreach (var actor in Model.Actors_Movies)
                                {
                                    <div class="card-columns text-center">
                                        <img class="border-info rounded-circle" src="@actor.Actor.ProfilePictureURL" style="max-width:150px" />
                                        <br />
                                        <a asp-controller="Actors" asp-action="Details" asp-route-id="@Model.Id">@actor.Actor.FullName</a>
                                    </div>
                                }
                            </div>
                        </p>
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="card-footer">
                        <p class="cart-text">
                            <a class="btn btn-outline-primary float-right" asp-action="Index">
                                Back To List
                            </a>
                            <a class="btn btn-success text-white " asp-controller="Orders" asp-action="AddItemToShoppingCart" asp-route-id="@Model.Id">
                                <i class="bi bi-cart-plus"></i>
                                Add to Cart (Price @Model.Price.ToString("c"))
                            </a>
                        </p>
                    </div>
                </div>
                
            </div>
        </div>
    </div>
    
</div>

Views/Movies/Index.cshtml
@model IEnumerable<eTicket.Models.Movie>

@{
    ViewData["Title"] = "List Of Movies";
}

<h1>Index</h1>

<p>
    <a asp-action="Create">Create New</a>
</p>
<div class="row">
    @foreach (var item in Model)
    {
        <div class="col-md-4 col-xs-6 border-primary mb-3">
            <div class="card mb-3" style="max-width:540px">
                <div class="row g-0">
                    <div class="col-md-12">
                        <div class="card-header text-white bg-info">
                            <p class="card-text">
                                <h5 class="card-title">
                                    @item.Name
                                    <a class="text-white float-right" asp-action="Edit" asp-route-id="@item.Id"><i class="bi bi-pencil-square"></i></a>
                                </h5>
                            </p>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <img src="@item.ImageURL" width="100%" alt="@item.Name" />
                    </div>
                    <div class="col-md-6">
                        <div class="card-body">
                            <p class="card-text">@item.Description</p>
                            <p class="card-text"><b>Cinema: </b>@item.Cinema.Name</p>
                            @*<p class="card-text"><b>Cinema: </b>@item.Producer.FullName</p>*@
                            <p class="card-text"><b>Category: </b>@item.MovieCategory</p>
                            <p class="card-text"><b>Start Date: </b>@item.StartDate.ToShortDateString() </p>
                            <p class="card-text"><b>End Date: </b>@item.EndDate.ToShortDateString()</p>
                            <p class="card-text">
                                <b>Status: </b>
                                @if (DateTime.Now >= item.StartDate && DateTime.Now <= item.EndDate)
                                {
                                    <span class="badge bg-success text-white">AVAILABLE</span>
                                }
                                else if (DateTime.Now > item.EndDate)
                                {
                                    <span class="badge bg-danger text-white">Expired</span>
                                }
                                else
                                {
                                    <span class="badge bg-success text-white">AVAILABLE</span>
                                }
                            </p>
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="card-footer">
                            <p class="cart-text">
                                <a class="btn btn-outline-primary float-right" asp-action="Details" asp-route-id="@item.Id">
                                    <i class="bi bi-eye-fill"></i>
                                    Show Details
                                </a>
                                <a class="btn btn-success text-white" asp-controller="Orders" asp-action="AddItemToShoppingCart" asp-route-id="@item.Id">
                                    <i class="bi bi-cart-plus"></i>
                                    Add to Cart (Price @item.Price.ToString("c"))
                                </a>
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    }
</div>


@await Html.PartialAsync("_CreateItem","Movies")